## org.apache.xml.serializer
Class ToTextSAXHandler

    java.lang.Object
      org.apache.xml.serializer.SerializerBase
          org.apache.xml.serializer.ToSAXHandler
              org.apache.xml.serializer.ToTextSAXHandler

All Implemented Interfaces:
  ContentHandler, DeclHandler, DOM2DTM.CharacterNodeHandler, DOMSerializer, ErrorHandler, ExtendedContentHandler, ExtendedLexicalHandler, LexicalHandler, SerializationHandler, Serializer, SerializerConstants, XSLOutputAttributes

public class ToTextSAXHandler
extends ToSAXHandler

Author:
  minchau To change this generated comment edit the template variable "typecomment": Window>Preferences>Java>Templates. To enable and disable the creation of type comments go to Window>Preferences>Java>Code Generation., Santiago Pericas-Geertsen

Field Summary

Fields inherited from interface org.apache.xml.serializer.ExtendedContentHandler
`HTML_ATTREMPTY, HTML_ATTRURL, NO_BAD_CHARS`

Fields inherited from interface org.apache.xml.serializer.SerializerConstants
`BEGCDATA, CDATA_CONTINUE, CDATA_DELIMITER_CLOSE, CDATA_DELIMITER_OPEN, CNTCDATA, DEFAULT_SAX_SERIALIZER, EMPTYSTRING, ENDCDATA, ENTITY_AMP, ENTITY_CRLF, ENTITY_GT, ENTITY_LT, ENTITY_QUOT, XML_PREFIX, XMLNS_PREFIX, XMLNS_URI`

Constructor Summary
`ToTextSAXHandler(ContentHandler hdlr, LexicalHandler lex, java.lang.String encoding)`
`ToTextSAXHandler(ContentHandler handler, java.lang.String encoding)` From XSLTC

Method Summary
`void` `addAttribute(java.lang.String name, java.lang.String value)` From XSLTC
`void` `addAttribute(java.lang.String uri, java.lang.String localName, java.lang.String rawName, java.lang.String type, java.lang.String value)` Adds the given attribute to the set of collected attributes , but only if there is a currently open element.
`void` `attributeDecl(java.lang.String arg0, java.lang.String arg1, java.lang.String arg2, java.lang.String arg3, java.lang.String arg4)` Report an attribute type declaration.
`void` `characters(char[] characters, int offset, int length)` Receive notification of character data.
`void` `characters(java.lang.String characters)` Receive notification of character data.
`void` `comment(char[] ch, int start, int length)` Report an XML comment anywhere in the document.
`void` `comment(java.lang.String data)` Receive notification of a comment.
`void` `elementDecl(java.lang.String arg0, java.lang.String arg1)` Report an element type declaration.
`void` `endCDATA()` Report the end of a CDATA section.
`void` `endDocument()` From XSLTC
`void` `endDTD()` Report the end of DTD declarations.
`void` `endElement(java.lang.String elemName)` From XSLTC
`void` `endElement(java.lang.String arg0, java.lang.String arg1, java.lang.String arg2)` Receive notification of the end of an element.
`void` `endPrefixMapping(java.lang.String arg0)` End the scope of a prefix-URI mapping.
`void` `externalEntityDecl(java.lang.String arg0, java.lang.String arg1, java.lang.String arg2)` Report a parsed external entity declaration.
`java.util.Properties` `getOutputFormat()` Returns the output format properties for this serializer.
`java.io.OutputStream` `getOutputStream()` Get the output stream where the events will be serialized to.
`java.io.Writer` `getWriter()` Get the character stream where the events will be serialized to.
`void` `ignorableWhitespace(char[] arg0, int arg1, int arg2)` Receive notification of ignorable whitespace in element content.
`void` `indent(int n)` Does nothing because the indent attribute is ignored for text output.
`void` `internalEntityDecl(java.lang.String arg0, java.lang.String arg1)` Report an internal entity declaration.
`void` `namespaceAfterStartElement(java.lang.String prefix, java.lang.String uri)` This method is used when a prefix/uri namespace mapping is indicated after the element was started with a startElement() and before and endElement().
`void` `processingInstruction(java.lang.String arg0, java.lang.String arg1)` From XSLTC
`boolean` `reset()` Try's to reset the super class and reset this class for re-use, so that you don't need to create a new serializer (mostly for performance reasons).
`void` `serialize(Node node)` Notify that the serializer should take this DOM node as input to be serialized.
`void` `setDocumentLocator(Locator arg0)` Receive an object for locating the origin of SAX document events.
`boolean` `setEscaping(boolean escape)` Turns special character escaping on/off.
`void` `setIndent(boolean indent)` Sets the value coming from the xsl:output indent stylesheet attribute.
`void` `setOutputFormat(java.util.Properties format)` Specifies an output format for this serializer.
`void` `setOutputStream(java.io.OutputStream output)` Specifies an output stream to which the document should be serialized.
`void` `setWriter(java.io.Writer writer)` Specifies a writer to which the document should be serialized.
`void` `skippedEntity(java.lang.String arg0)` Receive notification of a skipped entity.
`void` `startCDATA()` Report the start of a CDATA section.
`void` `startElement(java.lang.String elementName)` An element starts, but attributes are not fully known yet.
`void` `startElement(java.lang.String elementNamespaceURI, java.lang.String elementLocalName, java.lang.String elementName)` From XSLTC
`void` `startElement(java.lang.String arg0, java.lang.String arg1, java.lang.String arg2, Attributes arg3)` Receive notification of the beginning of an element, although this is a SAX method additional namespace or attribute information can occur before or after this call, that is associated with this element.
`void` `startEntity(java.lang.String arg0)` Report the beginning of some internal and external XML entities.
`void` `startPrefixMapping(java.lang.String prefix, java.lang.String uri)` Begin the scope of a prefix-URI Namespace mapping.
`boolean` `startPrefixMapping(java.lang.String prefix, java.lang.String uri, boolean shouldFlush)` This method is used to notify that a prefix maping is to start, which can be for the current element, or for the one to come.

Methods inherited from class org.apache.xml.serializer.ToSAXHandler
`addUniqueAttribute, characters, error, fatalError, flushPending, setCdataSectionElements, setContentHandler, setLexHandler, setShouldOutputNSAttr, setTransformState, startDTD, warning`

Methods inherited from class org.apache.xml.serializer.SerializerBase

`addAttributeAlways, addAttributes, asContentHandler, asDOMSerializer, close, endEntity, entityReference, fireEndEntity, getDoctypePublic, getDoctypeSystem, getEncoding, getIndent, getIndentAmount, getMediaType, getNamespaceMappings, getNamespaceURI, getNamespaceURIFromPrefix, getOmitXMLDeclaration, getPrefix, getStandalone, getTransformer, getVersion, setDoctype, setDoctypePublic, setDoctypeSystem, setEncoding, setIndentAmount, setMediaType, setNamespaceMappings, setOmitXMLDeclaration, setSourceLocator, setStandalone, setTransformer, setVersion, startDocument`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### ToTextSAXHandler

    public ToTextSAXHandler(ContentHandler hdlr,
                            LexicalHandler lex,
                            java.lang.String encoding)

### ToTextSAXHandler

    public ToTextSAXHandler(ContentHandler handler,
                            java.lang.String encoding)

  From XSLTC

Method Detail

### endElement

    public void endElement(java.lang.String elemName)
                    throws SAXException

  From XSLTC

  Parameters:
    `elemName` - the fully qualified element name.
  Throws:
    `SAXException`
  See Also:
    `ExtendedContentHandler.endElement(String)`

### endElement

    public void endElement(java.lang.String arg0,
                           java.lang.String arg1,
                           java.lang.String arg2)
                    throws SAXException

  Description copied from interface: `ContentHandler`
  Receive notification of the end of an element.

  The SAX parser will invoke this method at the end of every element in the XML document; there will be a corresponding `startElement` event for every endElement event (even when the element is empty).

  For information on the names, see startElement.

  Parameters:
    `arg0` - The Namespace URI, or the empty string if the element has no Namespace URI or if Namespace processing is not being performed.
    `arg1` - The local name (without prefix), or the empty string if Namespace processing is not being performed.
    `arg2` - The qualified XML 1.0 name (with prefix), or the empty string if qualified names are not available.
  Throws:
    `SAXException` - Any SAX exception, possibly wrapping another exception.
  See Also:
    `ContentHandler.endElement(String, String, String)`

### comment

    public void comment(char[] ch,
                        int start,
                        int length)
                 throws SAXException

  Description copied from interface: `LexicalHandler`
  Report an XML comment anywhere in the document.

  This callback will be used for comments inside or outside the document element, including comments in the external DTD subset (if read). Comments in the DTD must be properly nested inside start/endDTD and start/endEntity events (if used).

  Parameters:
    `ch` - An array holding the characters in the comment.
    `start` - The starting position in the array.
    `length` - The number of characters to use from the array.
  Throws:
    `SAXException` - The application may raise an exception.

### comment

    public void comment(java.lang.String data)
                 throws SAXException

  Description copied from class: `ToSAXHandler`
  Receive notification of a comment.

  Specified by:
    `comment` in interface `ExtendedLexicalHandler`
  Overrides:
    `comment` in class `ToSAXHandler`
  Throws:
    `SAXException`
  See Also:
    `ExtendedLexicalHandler.comment(String)`

### getOutputFormat

    public java.util.Properties getOutputFormat()

  Description copied from interface: `Serializer`
  Returns the output format properties for this serializer.

  Returns:
    The output format in use
  See Also:
    `Serializer.getOutputFormat()`

### getOutputStream

    public java.io.OutputStream getOutputStream()

  Description copied from interface: `Serializer`
  Get the output stream where the events will be serialized to.

  Returns:
    reference to the result stream, or null of only a writer was set.
  See Also:
    `Serializer.getOutputStream()`

### getWriter

    public java.io.Writer getWriter()

  Description copied from interface: `Serializer`
  Get the character stream where the events will be serialized to.

  Returns:
    Reference to the result Writer, or null.
  See Also:
    `Serializer.getWriter()`

### indent

    public void indent(int n)
                throws SAXException

  Does nothing because the indent attribute is ignored for text output.

  Throws:
    `SAXException`

### reset

    public boolean reset()

  Description copied from class: `ToSAXHandler`
  Try's to reset the super class and reset this class for re-use, so that you don't need to create a new serializer (mostly for performance reasons).

  Specified by:
    `reset` in interface `Serializer`
  Overrides:
    `reset` in class `ToSAXHandler`
  Returns:
    true if the class was successfuly reset.
  See Also:
    `Serializer.reset()`

### serialize

    public void serialize(Node node)
                   throws java.io.IOException

  Description copied from interface: `SerializationHandler`
  Notify that the serializer should take this DOM node as input to be serialized.

  Parameters:
    `node` - the DOM node to be serialized.
  Throws:
    `java.io.IOException`
  See Also:
    `DOMSerializer.serialize(Node)`

### setEscaping

    public boolean setEscaping(boolean escape)

  Description copied from interface: `SerializationHandler`
  Turns special character escaping on/off. Note that characters will never, even if this option is set to 'true', be escaped within CDATA sections in output XML documents.

  See Also:
    `SerializationHandler.setEscaping(boolean)`

### setIndent

    public void setIndent(boolean indent)

  Description copied from class: `SerializerBase`
  Sets the value coming from the xsl:output indent stylesheet attribute.

  Specified by:
    `setIndent` in interface `XSLOutputAttributes`
  Overrides:
    `setIndent` in class `SerializerBase`
  Parameters:
    `indent` - true if the output document should be indented to visually indicate its structure.
  See Also:
    `XSLOutputAttributes.setIndent(boolean)`

### setOutputFormat

    public void setOutputFormat(java.util.Properties format)

  Description copied from interface: `Serializer`
  Specifies an output format for this serializer. It the serializer has already been associated with an output format, it will switch to the new format. This method should not be called while the serializer is in the process of serializing a document.

  Parameters:
    `format` - The output format to use
  See Also:
    `Serializer.setOutputFormat(Properties)`

### setOutputStream

    public void setOutputStream(java.io.OutputStream output)

  Description copied from interface: `Serializer`
  Specifies an output stream to which the document should be serialized. This method should not be called while the serializer is in the process of serializing a document.

  The encoding specified in the output `Properties` is used, or if no encoding was specified, the default for the selected output method.

  Parameters:
    `output` - The output stream
  See Also:
    `Serializer.setOutputStream(OutputStream)`

### setWriter

    public void setWriter(java.io.Writer writer)

  Description copied from interface: `Serializer`
  Specifies a writer to which the document should be serialized. This method should not be called while the serializer is in the process of serializing a document.

  The encoding specified for the output `Properties` must be identical to the output format used with the writer.

  Parameters:
    `writer` - The output writer stream
  See Also:
    `Serializer.setWriter(Writer)`

### addAttribute

    public void addAttribute(java.lang.String uri,
                             java.lang.String localName,
                             java.lang.String rawName,
                             java.lang.String type,
                             java.lang.String value)

  Description copied from class: `SerializerBase`
  Adds the given attribute to the set of collected attributes , but only if there is a currently open element. An element is currently open if a startElement() notification has occured but the start of the element has not yet been written to the output. In the stream case this means that we have not yet been forced to close the elements opening tag by another notification, such as a character notification.

  Specified by:
    `addAttribute` in interface `ExtendedContentHandler`
  Overrides:
    `addAttribute` in class `SerializerBase`
  Parameters:
    `uri` - the URI of the attribute
    `localName` - the local name of the attribute
    `rawName` - the qualified name of the attribute
    `type` - the type of the attribute (probably CDATA)
    `value` - the value of the attribute
  See Also:
    `ExtendedContentHandler.addAttribute(String, String, String, String, String)`

### attributeDecl

    public void attributeDecl(java.lang.String arg0,
                              java.lang.String arg1,
                              java.lang.String arg2,
                              java.lang.String arg3,
                              java.lang.String arg4)
                       throws SAXException

  Description copied from interface: `DeclHandler`
  Report an attribute type declaration.

  Only the effective (first) declaration for an attribute will be reported. The type will be one of the strings "CDATA", "ID", "IDREF", "IDREFS", "NMTOKEN", "NMTOKENS", "ENTITY", "ENTITIES", a parenthesized token group with the separator "|" and all whitespace removed, or the word "NOTATION" followed by a space followed by a parenthesized token group with all whitespace removed.

  The value will be the value as reported to applications, appropriately normalized and with entity and character references expanded.

  Parameters:
    `arg0` - The name of the associated element.
    `arg1` - The name of the attribute.
    `arg2` - A string representing the attribute type.
    `arg3` - A string representing the attribute defaulting mode ("#IMPLIED", "#REQUIRED", or "#FIXED") or null if none of these applies.
    `arg4` - A string representing the attribute's default value, or null if there is none.
  Throws:
    `SAXException` - The application may raise an exception.
  See Also:
    `DeclHandler.attributeDecl(String, String, String, String, String)`

### elementDecl

    public void elementDecl(java.lang.String arg0,
                            java.lang.String arg1)
                     throws SAXException

  Description copied from interface: `DeclHandler`
  Report an element type declaration.

  The content model will consist of the string "EMPTY", the string "ANY", or a parenthesised group, optionally followed by an occurrence indicator. The model will be normalized so that all parameter entities are fully resolved and all whitespace is removed,and will include the enclosing parentheses. Other normalization (such as removing redundant parentheses or simplifying occurrence indicators) is at the discretion of the parser.

  Parameters:
    `arg0` - The element type name.
    `arg1` - The content model as a normalized string.
  Throws:
    `SAXException` - The application may raise an exception.
  See Also:
    `DeclHandler.elementDecl(String, String)`

### externalEntityDecl

    public void externalEntityDecl(java.lang.String arg0,
                                   java.lang.String arg1,
                                   java.lang.String arg2)
                            throws SAXException

  Description copied from interface: `DeclHandler`
  Report a parsed external entity declaration.

  Only the effective (first) declaration for each entity will be reported.

  Parameters:
    `arg0` - The name of the entity. If it is a parameter entity, the name will begin with '%'.
    `arg1` - The declared public identifier of the entity, or null if none was declared.
    `arg2` - The declared system identifier of the entity.
  Throws:
    `SAXException` - The application may raise an exception.
  See Also:
    `DeclHandler.externalEntityDecl(String, String, String)`

### internalEntityDecl

    public void internalEntityDecl(java.lang.String arg0,
                                   java.lang.String arg1)
                            throws SAXException

  Description copied from interface: `DeclHandler`
  Report an internal entity declaration.

  Only the effective (first) declaration for each entity will be reported. All parameter entities in the value will be expanded, but general entities will not.

  Parameters:
    `arg0` - The name of the entity. If it is a parameter entity, the name will begin with '%'.
    `arg1` - The replacement text of the entity.
  Throws:
    `SAXException` - The application may raise an exception.
  See Also:
    `DeclHandler.internalEntityDecl(String, String)`

### endPrefixMapping

    public void endPrefixMapping(java.lang.String arg0)
                          throws SAXException

  Description copied from interface: `ContentHandler`
  End the scope of a prefix-URI mapping.

  See `startPrefixMapping` for details. These events will always occur immediately after the corresponding `endElement` event, but the order of `endPrefixMapping` events is not otherwise guaranteed.

  Parameters:
    `arg0` - The prefix that was being mapping. This is the empty string when a default mapping scope ends.
  Throws:
    `SAXException` - The client may throw an exception during processing.
  See Also:
    `ContentHandler.endPrefixMapping(String)`

### ignorableWhitespace

    public void ignorableWhitespace(char[] arg0,
                                    int arg1,
                                    int arg2)
                             throws SAXException

  Description copied from interface: `ContentHandler`
  Receive notification of ignorable whitespace in element content.

  Validating Parsers must use this method to report each chunk of whitespace in element content (see the W3C XML 1.0 recommendation, section 2.10): non-validating parsers may also use this method if they are capable of parsing and using content models.

  SAX parsers may return all contiguous whitespace in a single chunk, or they may split it into several chunks; however, all of the characters in any single event must come from the same external entity, so that the Locator provides useful information.

  The application must not attempt to read from the array outside of the specified range.

  Parameters:
    `arg0` - The characters from the XML document.
    `arg1` - The start position in the array.
    `arg2` - The number of characters to read from the array.
  Throws:
    `SAXException` - Any SAX exception, possibly wrapping another exception.
  See Also:
    `ContentHandler.ignorableWhitespace(char[], int, int)`

### processingInstruction

    public void processingInstruction(java.lang.String arg0,
                                      java.lang.String arg1)
                               throws SAXException

  From XSLTC

  Specified by:
    `processingInstruction` in interface `ContentHandler`
  Overrides:
    `processingInstruction` in class `ToSAXHandler`
  Throws:
    `SAXException`
  See Also:
    `ContentHandler.processingInstruction(String, String)`

### setDocumentLocator

    public void setDocumentLocator(Locator arg0)

  Description copied from class: `SerializerBase`
  Receive an object for locating the origin of SAX document events.

  Specified by:
    `setDocumentLocator` in interface `ContentHandler`
  Overrides:
    `setDocumentLocator` in class `SerializerBase`
  Parameters:
    `arg0` - An object that can return the location of any SAX document event. Receive an object for locating the origin of SAX document events.

    SAX parsers are strongly encouraged (though not absolutely required) to supply a locator: if it does so, it must supply the locator to the application by invoking this method before invoking any of the other methods in the DocumentHandler interface.

    The locator allows the application to determine the end position of any document-related event, even if the parser is not reporting an error. Typically, the application will use this information for reporting its own errors (such as character content that does not match an application's business rules). The information returned by the locator is probably not sufficient for use with a search engine.

    Note that the locator will return correct information only during the invocation of the events in this interface. The application should not attempt to use it at any other time.

  See Also:
    `ContentHandler.setDocumentLocator(Locator)`

### skippedEntity

    public void skippedEntity(java.lang.String arg0)
                       throws SAXException

  Description copied from interface: `ContentHandler`
  Receive notification of a skipped entity. This is not called for entity references within markup constructs such as element start tags or markup declarations. (The XML recommendation requires reporting skipped external entities. SAX also reports internal entity expansion/non-expansion, except within markup constructs.)

  The Parser will invoke this method each time the entity is skipped. Non-validating processors may skip entities if they have not seen the declarations (because, for example, the entity was declared in an external DTD subset). All processors may skip external entities, depending on the values of the `http://xml.org/sax/features/external-general-entities` and the `http://xml.org/sax/features/external-parameter-entities` properties.

  Parameters:
    `arg0` - The name of the skipped entity. If it is a parameter entity, the name will begin with '%', and if it is the external DTD subset, it will be the string "[dtd]".
  Throws:
    `SAXException` - Any SAX exception, possibly wrapping another exception.
  See Also:
    `ContentHandler.skippedEntity(String)`

### startElement

    public void startElement(java.lang.String arg0,
                             java.lang.String arg1,
                             java.lang.String arg2,
                             Attributes arg3)
                      throws SAXException

  Description copied from class: `ToSAXHandler`
  Receive notification of the beginning of an element, although this is a SAX method additional namespace or attribute information can occur before or after this call, that is associated with this element.

  Specified by:
    `startElement` in interface `ContentHandler`
  Overrides:
    `startElement` in class `ToSAXHandler`
  Throws:
    `SAXException`
  See Also:
    `ContentHandler.startElement(String, String, String, Attributes)`

### endCDATA

    public void endCDATA()
                  throws SAXException

  Description copied from interface: `LexicalHandler`
  Report the end of a CDATA section.

  Throws:
    `SAXException` - The application may raise an exception.
  See Also:
    `LexicalHandler.endCDATA()`

### endDTD

    public void endDTD()
                throws SAXException

  Description copied from interface: `LexicalHandler`
  Report the end of DTD declarations.

  This method is intended to report the end of the DOCTYPE declaration; if the document has no DOCTYPE declaration, this method will not be invoked.

  Throws:
    `SAXException` - The application may raise an exception.
  See Also:
    `LexicalHandler.endDTD()`

### startCDATA

    public void startCDATA()
                    throws SAXException

  Description copied from interface: `LexicalHandler`
  Report the start of a CDATA section.

  The contents of the CDATA section will be reported through the regular `characters` event; this event is intended only to report the boundary.

  Throws:
    `SAXException` - The application may raise an exception.
  See Also:
    `LexicalHandler.startCDATA()`

### startEntity

    public void startEntity(java.lang.String arg0)
                     throws SAXException

  Description copied from interface: `LexicalHandler`
  Report the beginning of some internal and external XML entities.

  The reporting of parameter entities (including the external DTD subset) is optional, and SAX2 drivers that report LexicalHandler events may not implement it; you can use the `http://xml.org/sax/features/lexical-handler/parameter-entities` feature to query or control the reporting of parameter entities.

  General entities are reported with their regular names, parameter entities have '%' prepended to their names, and the external DTD subset has the pseudo-entity name "[dtd]".

  When a SAX2 driver is providing these events, all other events must be properly nested within start/end entity events. There is no additional requirement that events from `DeclHandler` or `DTDHandler` be properly ordered.

  Note that skipped entities will be reported through the `skippedEntity` event, which is part of the ContentHandler interface.

  Because of the streaming event model that SAX uses, some entity boundaries cannot be reported under any circumstances:

  - general entities within attribute values
  - parameter entities within declarations

  These will be silently expanded, with no indication of where the original entity boundaries were.

  Note also that the boundaries of character references (which are not really entities anyway) are not reported.

  All start/endEntity events must be properly nested.

  Parameters:
    `arg0` - The name of the entity. If it is a parameter entity, the name will begin with '%', and if it is the external DTD subset, it will be "[dtd]".
  Throws:
    `SAXException` - The application may raise an exception.
  See Also:
    `LexicalHandler.startEntity(String)`

### startElement

    public void startElement(java.lang.String elementNamespaceURI,
                             java.lang.String elementLocalName,
                             java.lang.String elementName)
                      throws SAXException

  From XSLTC

  Specified by:
    `startElement` in interface `ExtendedContentHandler`
  Overrides:
    `startElement` in class `ToSAXHandler`
  Parameters:
    `elementNamespaceURI` - the URI of the namespace of the element (optional)
    `elementLocalName` - the element name, but without prefix (optional)
    `elementName` - the element name, with prefix, if any (required)
  Throws:
    `SAXException`
  See Also:
    `ExtendedContentHandler.startElement(String)`

### startElement

    public void startElement(java.lang.String elementName)
                      throws SAXException

  Description copied from class: `ToSAXHandler`
  An element starts, but attributes are not fully known yet.

  Specified by:
    `startElement` in interface `ExtendedContentHandler`
  Overrides:
    `startElement` in class `ToSAXHandler`
  Throws:
    `SAXException`
  See Also:
    `ExtendedContentHandler.startElement(String)`

### endDocument

    public void endDocument()
                     throws SAXException

  From XSLTC

  Throws:
    `SAXException` - Any SAX exception, possibly wrapping another exception.
  See Also:
    `ContentHandler.endDocument()`

### characters

    public void characters(java.lang.String characters)
                    throws SAXException

  Description copied from class: `ToSAXHandler`
  Receive notification of character data.

  Specified by:
    `characters` in interface `ExtendedContentHandler`
  Overrides:
    `characters` in class `ToSAXHandler`
  Throws:
    `SAXException`
  See Also:
    `ExtendedContentHandler.characters(String)`

### characters

    public void characters(char[] characters,
                           int offset,
                           int length)
                    throws SAXException

  Description copied from interface: `ContentHandler`
  Receive notification of character data.

  The Parser will call this method to report each chunk of character data. SAX parsers may return all contiguous character data in a single chunk, or they may split it into several chunks; however, all of the characters in any single event must come from the same external entity so that the Locator provides useful information.

  The application must not attempt to read from the array outside of the specified range.

  Individual characters may consist of more than one Java `char` value. There are two important cases where this happens, because characters can't be represented in just sixteen bits. In one case, characters are represented in a Surrogate Pair, using two special Unicode values. Such characters are in the so-called "Astral Planes", with a code point above U+FFFF. A second case involves composite characters, such as a base character combining with one or more accent characters.

  Your code should not assume that algorithms using `char`-at-a-time idioms will be working in character units; in some cases they will split characters. This is relevant wherever XML permits arbitrary characters, such as attribute values, processing instruction data, and comments as well as in data reported from this method. It's also generally relevant whenever Java code manipulates internationalized text; the issue isn't unique to XML.

  Note that some parsers will report whitespace in element content using the `ignorableWhitespace` method rather than this one (validating parsers must do so).

  Parameters:
    `characters` - The characters from the XML document.
    `offset` - The start position in the array.
    `length` - The number of characters to read from the array.
  Throws:
    `SAXException` - Any SAX exception, possibly wrapping another exception.
  See Also:
    `ContentHandler.characters(char[], int, int)`

### addAttribute

    public void addAttribute(java.lang.String name,
                             java.lang.String value)

  From XSLTC

  Specified by:
    `addAttribute` in interface `ExtendedContentHandler`
  Overrides:
    `addAttribute` in class `SerializerBase`
  Parameters:
    `name` - the attribute's qualified name
    `value` - the value of the attribute

### startPrefixMapping

    public boolean startPrefixMapping(java.lang.String prefix,
                                      java.lang.String uri,
                                      boolean shouldFlush)
                               throws SAXException

  Description copied from interface: `ExtendedContentHandler`
  This method is used to notify that a prefix maping is to start, which can be for the current element, or for the one to come.

  Parameters:
    `prefix` - the prefix that maps to the given URI
    `uri` - the namespace URI of the given prefix
    `shouldFlush` - if true this call is like the SAX startPrefixMapping(prefix,uri) call and the mapping applies to the element to come. If false the mapping applies to the current element.
  Returns:
    boolean false if the prefix mapping was already in effect (in other words we are just re-declaring), true if this is a new, never before seen mapping for the element.
  Throws:
    `SAXException`

### startPrefixMapping

    public void startPrefixMapping(java.lang.String prefix,
                                   java.lang.String uri)
                            throws SAXException

  Description copied from interface: `ContentHandler`
  Begin the scope of a prefix-URI Namespace mapping.

  The information from this event is not necessary for normal Namespace processing: the SAX XML reader will automatically replace prefixes for element and attribute names when the `http://xml.org/sax/features/namespaces` feature is true (the default).

  There are cases, however, when applications need to use prefixes in character data or in attribute values, where they cannot safely be expanded automatically; the start/endPrefixMapping event supplies the information to the application to expand prefixes in those contexts itself, if necessary.

  Note that start/endPrefixMapping events are not guaranteed to be properly nested relative to each other: all startPrefixMapping events will occur immediately before the corresponding `startElement` event, and all `endPrefixMapping` events will occur immediately after the corresponding `endElement` event, but their order is not otherwise guaranteed.

  There should never be start/endPrefixMapping events for the "xml" prefix, since it is predeclared and immutable.

  Parameters:
    `prefix` - The Namespace prefix being declared. An empty string is used for the default element namespace, which has no prefix.
    `uri` - The Namespace URI the prefix is mapped to.
  Throws:
    `SAXException` - The client may throw an exception during processing.
  See Also:
    `ContentHandler.endPrefixMapping(java.lang.String)`, `ContentHandler.startElement(java.lang.String, java.lang.String, java.lang.String, org.xml.sax.Attributes)`

### namespaceAfterStartElement

    public void namespaceAfterStartElement(java.lang.String prefix,
                                           java.lang.String uri)
                                    throws SAXException

  Description copied from class: `SerializerBase`
  This method is used when a prefix/uri namespace mapping is indicated after the element was started with a startElement() and before and endElement(). startPrefixMapping(prefix,uri) would be used before the startElement() call.

  Specified by:
    `namespaceAfterStartElement` in interface `ExtendedContentHandler`
  Overrides:
    `namespaceAfterStartElement` in class `SerializerBase`
  Parameters:
    `prefix` - the URI of the namespace
    `uri` - the prefix associated with the given URI.
  Throws:
    `SAXException`
  See Also:
    `ExtendedContentHandler.namespaceAfterStartElement(String, String)`

Copyright © 2004 Apache XML Project. All Rights Reserved.